/// \file FRM_Client.h
/// \date 2008/01/20
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _FRM_FRM_Client_h_
#define _FRM_FRM_Client_h_

#include "FRM_App.h"

namespace FRM
{
	/// \brief FClient Class
  class FClient : public FApp
	{
  public:
    static FClient* Instance() {
      return m_singleton;
    }

    static FClient* Make()
    {
      return 0;
    }

    static void Delete ()
    {
      if (m_singleton){
        delete m_singleton;
        m_singleton = 0;
      }
    }

  protected:
		//---------------------------------------
		/// \brief Default Constructor
		FClient();
		//---------------------------------------
		/// \brief Destructor
    virtual ~FClient();

    //---------------------------------------
    /// \brief initialise application
    virtual void Init () = 0;

    //---------------------------------------
    /// \brief update application
    virtual void Update () = 0;

    //---------------------------------------
    /// \brief close application
    virtual void Close () = 0;

    static FClient* m_singleton;
  };
}

#endif

