/// \file FRM_Dynamic.h
/// \date 2008/02/10
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _FRM_FRM_Dynamic_h_
#define _FRM_FRM_Dynamic_h_

#include "FRM_Transform.h"
#include <MCG/Def.h> // for MCG::Real
#include <MCG/Vector3.h>

namespace FRM
{
	/// \brief
  class FDynamic : public FTransform
	{
	public:
		//---------------------------------------
		/// \brief Default Constructor
		FDynamic() 
      : m_mass (1)
    {}
		//---------------------------------------
		/// \brief Destructor
		~FDynamic() {}

    MCG::Real GetMass () { return m_mass; }
    void SetMass (const MCG::Real& _m) { m_mass = _m; }

    MCG::Vector3 GetVelocity () { return m_velocity; }
    void SetVelocity (const MCG::Vector3& _v) { m_velocity = _v; }

    MCG::Vector3 GetAcceleration () { return m_acceleration; }
    void SetAcceleration (const MCG::Vector3& _a) { m_acceleration = _a; }

    virtual void Update (const unsigned& dt);
		
  protected:
    MCG::Real m_mass;
    MCG::Vector3 m_velocity;
    MCG::Vector3 m_acceleration;
	};
}

#endif