/// \file FRM_Effect.h
/// \date 2007/12/17
/// \author Peter Dodds
/// \brief
/// \note Copyright (C) 2007 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _FRM_Effect_h_
#define _FRM_Effect_h_

#include <SDL/SDL_mixer.h>

namespace FRM
{
  class Sound;

	/// \brief
	class Effect
	{
    friend class Sound;
		//---------------------------------------
		/// \brief Default Constructor
    Effect();
		//---------------------------------------
		/// \brief Destructor
		~Effect();

  public:
    bool Load (const char* filename);
    void Unload ();

    void SetChannel (const int ch = -1);

    int Play (const int loops = 0);
    void Stop ();

    bool isPlaying;

  private:
    Mix_Chunk* data;
		int channel;

	};
}

#endif

