/// \file FRM_NetworkMngr.h
/// \date 2008/02/08
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _FRM_FRM_NetworkMngr_h_
#define _FRM_FRM_NetworkMngr_h_

#include <queue>

namespace FRM
{
  class User_Packet
  {
  public:
    //---------------------------------------
    /// \brief Default Constructor
    User_Packet() {}
    //---------------------------------------
    /// \brief Destructor
    virtual ~User_Packet() {}
  };

	/// \brief
	class NetworkManager
	{
	public:
		//---------------------------------------
		/// \brief Default Constructor
		NetworkManager() {}
		//---------------------------------------
		/// \brief Destructor
		virtual ~NetworkManager() {}

    virtual bool Startup ();
    virtual bool Shutdown ();

    virtual bool Connect (const char* _IP);
    virtual bool Disconnect ();

    virtual void PushPacket (const User_Packet& _p);
    virtual void ProcessIn ();
    virtual void ProcessOut ();
		
  private:
    std::queue<User_Packet> packetOut;
	};
}

#endif