/// \file Render.h
/// \date 2007/12/01
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2007 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _FRM_Render_h_
#define _FRM_Render_h_

#ifndef FRM_WIN_DEFAULT_W
#define FRM_WIN_DEFAULT_W 800
#endif
#ifndef FRM_WIN_DEFAULT_H
#define FRM_WIN_DEFAULT_H 600
#endif

struct SDL_Surface;

namespace FRM
{
  class FApp;

	/// \brief
	class FRender
	{
	public:
		//---------------------------------------
		/// \brief Default Constructor
		FRender();
		//---------------------------------------
		/// \brief Destructor
		virtual ~FRender();
		
    virtual void Init (const unsigned& width = 800, const unsigned& height = 600, const char* windowName = "FRM Game");

  protected:
    virtual void Init_Projection ();
    virtual void Init_Additional ();
    
  public:
    virtual void Update () = 0;
    virtual void Resize (const unsigned& width = 800, const unsigned& height = 600);
    virtual void ToggleFullScreen ();

    unsigned m_width, m_height;
    bool fullscreen;

  protected:
    SDL_Surface* sdlSurface;
    FApp* _frm_app;
	};
}

#endif

