/// \file FRM_Server.h
/// \date 2008/01/20
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _FRM_FRM_Server_h_
#define _FRM_FRM_Server_h_

#include "FRM_App.h"

namespace FRM
{
	/// \brief
  class FServer : public FApp
	{

  public:
    static FServer* Instance() {
      return m_singleton;
    }

    static FServer* Make()
    {
      return 0;
    }

    static void Delete ()
    {
      if (m_singleton){
        delete m_singleton;
        m_singleton = 0;
      }
    }

  protected:
    //---------------------------------------
    /// \brief Default Constructor
    FServer();
    //---------------------------------------
    /// \brief Destructor
    virtual ~FServer();

    //---------------------------------------
    /// \brief initialise application
    virtual void Init () = 0;

    //---------------------------------------
    /// \brief update application
    virtual void Update () = 0;

    //---------------------------------------
    /// \brief close application
    virtual void Close () = 0;

    static FServer* m_singleton;
  };
}

#endif

