/// \file Status.h
/// \date 2007/12/01
/// \author Peter Dodds
/// \brief
/// \note Copyright (C) 2007 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _FRM_Status_h_
#define _FRM_Status_h_

// array IDs for Status::initTable
#define FRM_GL 0
#define FRM_SDL 1
#define FRM_GLUT 2
#define FRM_DEVIL 3
#define FRM_INIT_TABLE_MAX 4

/// \brief possible game states
enum FRM_GameState
{
  k_State_Error = 0,
  k_State_Startup, // on startup
  k_State_Exit, // on exit
  k_State_Game, // in game
  k_State_Pause // when paused
};

namespace FRM
{
	/// \brief
	class Status
	{
	public:
		//---------------------------------------
		/// \brief Default Constructor
		Status();
		//---------------------------------------
		/// \brief Destructor
		~Status();

    void Update ();
    bool ToggleDebug ();

    bool Set (FRM_GameState _state);
    FRM_GameState Get ();

    bool debug;
    bool initTable [FRM_INIT_TABLE_MAX];

  private:
    FRM_GameState state;
	};
}

#endif
