/// \file FRM_Thread.h
/// \date 2008/01/15
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _FRM_FRM_Thread_h_
#define _FRM_FRM_Thread_h_

#include <pthread.h>

namespace FRM
{
	/// \brief
	class Thread
	{
	public:
		//---------------------------------------
		/// \brief Default Constructor
		Thread();
		//---------------------------------------
		/// \brief Destructor, cancels thread if running
		virtual ~Thread();

    //
    //---------------------------------------
    /// \brief Create the thread
    /// \param "void* (* fnct)(void*)" entry point function. if 0, Thread::Execute() will be called
    /// \param "void* data" data to be passed to fnct
    /// \return "bool" success
    bool Create (void* (*fnct)(void*) = 0, void* data = 0);
    //---------------------------------------
    /// \brief Wait for thread to finish execution
    /// \return "void*" status (to be cast to correct data type)
    void* Join ();

    //---------------------------------------
    /// \brief Default thread entry point
    virtual void Execute ();

    bool isRunning;

  protected:
    pthread_t m_pthread;
  };
}

#endif

