/// \file Time.h
/// \date 2007/12/01
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2007 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _FRM_Time_h_
#define _FRM_Time_h_

namespace FRM
{
	/// \brief class to access and track time
	class Time
	{
	public:
		//---------------------------------------
		/// \brief Default Constructor
    Time();
    //---------------------------------------
    /// \brief Destructor
		~Time();
		
    //---------------------------------------
    /// \brief Get time
    /// \return "unsigned" time in milliseconds
    unsigned GetTime ();
    //---------------------------------------
    /// \brief Get the difference in time (dt) 
    /// since last call to Time::GetDT()
    /// \return "unsigned" dt in milliseconds
    unsigned GetDT ();

    //---------------------------------------
    /// \brief Reset time to zero
    void Reset ();

  private:
    unsigned m_prev_time; ///< time at last call to Time::GetDT()
    unsigned m_offset; ///< offset from true time applied by Time::Reset()
	};
}

#endif
