/// \file Utl.h
/// \date 2007/12/03
/// \author Peter Dodds
/// \brief
/// \note Copyright (C) 2007 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _FRM_Utl_h_
#define _FRM_Utl_h_

#include <MCG/Matrix.h>
#include "FRM_Transform.h"
#include "FRM_Texture.h"

#define FRM_X_AXIS 1
#define FRM_Y_AXIS 2
#define FRM_Z_AXIS 4

#ifndef FRM_SLEEP

#endif

void FRM_Utl_MultMatrix (MCG::Matrix& mat);

/// \brief draw axis
void FRM_Utl_DrawAxis (const int& s = 1);

/// \brief draw a grid
void FRM_Utl_DrawGrid (const int& s = 50, const char axis = FRM_Y_AXIS);

/// \brief draw a circle
void FRM_Utl_DrawCircle (bool solid = true, const int& s = 10, const char axis = FRM_X_AXIS);

void FRM_Utl_DrawSquare (bool solid = true, const float& w = 10, const float& h = 10, const char axis = FRM_X_AXIS);

void FRM_Utl_DrawWireSphere (const int& S = 10, const int& lines = 10);

void FRM_Utl_DrawTransfPivot (FRM::FTransform& T);

void FRM_Utl_DrawSprite (FRM::FTexture& T, const float& w = 10, const float& h = 10, const char axis = FRM_X_AXIS);

void FRM_Utl_Sleep (unsigned milliseconds);

#endif
