/// \file AiMove.h
/// \date 2008/02/29
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _BUG_AiMove_h_
#define _BUG_AiMove_h_

#include "AiOrder.h"
#include "AiDef.h"

/// \brief possible types of AiMove
enum
{
  BUG_Move_NULL, ///< null value of the basic

  BUG_Move_Goto, ///< goto movement

  BUG_Move_User_Enum ///< user expandable enum value
};

namespace BUG
{
	/// \brief movement subset of AiOrder, to distinguish in queues
  class AiMove : public AiOrder
	{
	public:
		//---------------------------------------
		/// \brief Default Constructor
    AiMove(BUGu8 type)
      : AiOrder(type)
    {}
		//---------------------------------------
		/// \brief Destructor
		virtual ~AiMove() {}
	};

  /// \brief simple goto order
  class AiMove_Goto : public AiMove
  {
  public:
    //---------------------------------------
    /// \brief Default Constructor
    AiMove_Goto()
      : AiMove(BUG_Move_Goto)
    { }

    Vector goal; ///< location to goto
  };
}

#endif