/// \file AiPath.h
/// \date 2008/02/19
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _BUG_AiPath_h_
#define _BUG_AiPath_h_

#include <vector>

namespace BUG
{
  class AiPathfinder;
  class AiPathNode;

  /// \brief a glorified vector<AiPathNode*>
	class AiPath
	{
    friend class AiPathfinder;

	public:
		//---------------------------------------
		/// \brief Default Constructor
		AiPath() {}
		//---------------------------------------
		/// \brief Destructor
		~AiPath() {}

    // -----------------------------------
    /// \brief copy operation
    virtual const AiPath& operator = (const AiPath& path)
    {
      nodes = path.nodes;
      return *this;
    }


    // -----------------------------------
    /// \brief get a pointer to the AiPathNode
    virtual AiPathNode* operator[] (unsigned _i) const { return nodes[_i]; }
    // -----------------------------------
    /// \brief Get the size of the Path
    /// \returns "unsigned" the number of nodes
    virtual unsigned size() const { return (unsigned)nodes.size(); }
		
  protected:
    std::vector<AiPathNode*> nodes; ///< the nodes that make up the path
	};
}

#endif