/// \file AiPathNode.h
/// \date 2008/02/19
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _BUG_AiPathNode_h_
#define _BUG_AiPathNode_h_

#include "AiDef.h"
#include <vector>

namespace BUG
{
  class AiPathfinder;

  /// \brief A node (or waypoint) part of the AI world
	class AiPathNode
	{
  friend class AiPathfinder;
  protected:
		//---------------------------------------
		/// \brief Default Constructor
		AiPathNode()
      : aStar_parent (0), m_toll (0)
    {}
		//---------------------------------------
		/// \brief Destructor
    virtual ~AiPathNode() {}

  public:
		Vector m_pos; ///< position of node
    unsigned m_toll; ///< the cost of moving onto the node

    std::vector<AiPathNode*> m_successors; ///< links to neighboring points

  protected:
    unsigned id; ///< unique ID

    /// variables used during A* algorithm
    unsigned aStar_cost;
    unsigned aStar_goalDistance;
    AiPathNode* aStar_parent;
	};
}

#endif