/// \file Application.h
/// \date 2008/01/24
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _Roach_Application_h_
#define _Roach_Application_h_

#include <FRM/FRM_Client.h>
#include <FRM/FRM_Text.h>
#include "Render.h"
#include "Input.h"
#include "World.h"

enum
{
  App_Mode_Play,
  App_Mode_Units,
  App_Mode_Instances,
  App_Mode_PathNodes
};

namespace Roach
{
	/// \brief
  class Application : public FRM::FClient
	{
  public:
    static Application* Instance() {
      return (Application*)m_singleton;
    }

    static Application* Make() {
      if (m_singleton)
        return 0;
      m_singleton = new Application ();
      return (Application*)m_singleton;
    }

    // Delete is implemented in FRM::FClient

  private:
		//---------------------------------------
		/// \brief Default Constructor
		Application();
		//---------------------------------------
		/// \brief Destructor
		~Application() {}

  protected:
    //---------------------------------------
    /// \brief init Application
    void Init ();
    //---------------------------------------
    /// \brief update Application
    void Update ();
    //---------------------------------------
    /// \brief close Application
    void Close ();

  public:
    Render m_render;
    Input m_input;
    World m_world;

    unsigned char m_mode;
	};
}

#endif