/// \file Instance.h
/// \date 2008/02/15
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _Roach_Instance_h_
#define _Roach_Instance_h_

#include <MCG/Vector2.h>
#include <FRM/FRM_Transform.h>
#include <FRM/FRM_Texture.h>
#include "BShape.h"

#include <BUG/AiBlock.h>

namespace Roach
{
	/// \brief
	class Instance
	{
	public:
		//---------------------------------------
		/// \brief Default Constructor
		Instance();
		//---------------------------------------
		/// \brief Destructor
		~Instance() {}

    unsigned GetID () {return m_id;}
    void Update () 
    {
      m_block.m_pos.x = m_T.GetTranslation().x;
      m_block.m_pos.y = m_T.GetTranslation().y;
    }
		
    MCG::Real m_width, m_height;
    MCG::Real m_centreX, m_centreY;
    //BShape m_bshape;
    
    BUG::AiBlock_Polygon m_block;

    FRM::FTransform m_T;
    FRM::FTexture* m_texture;

  protected:
    unsigned m_id;

  private:
    static unsigned GetUniqueID () {return _nextID++;}
    static unsigned _nextID;
	};
}

#endif