/// \file Render.h
/// \date 2008/01/24
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _Roach_Render_h_
#define _Roach_Render_h_

#include <FRM/FRM_Render.h>

#include <FRM/FRM_Camera.h>
#include <MCG/Vector2.h>
#include <MCG/Vector4.h>

#include <BUG/AiPath.h>

enum{
  Render_visuals,
  Render_debug,
  Render_visuals_and_debug
};

namespace Roach
{
	/// \brief
  class Render : public FRM::FRender
	{
	public:
		//---------------------------------------
		/// \brief Default Constructor
		Render();
		//---------------------------------------
		/// \brief Destructor
		~Render();
		
    void Update();
    MCG::Vector2 Screen2World (const MCG::Vector2& pnt)
    {
      MCG::Vector2 _return (pnt.x, m_height - pnt.y);
      _return *= z_distance;
      _return -= m_camera.GetTranslation();
      return _return;
    }

    FRM::FCamera m_camera;

    unsigned char state;

  protected:
    void Init_Projection ();
    void Init_Additional ();


  private:
    void RenderVisuals ();
    void RenderDebug ();

#if 0
    void DrawInstances (unsigned id = 0, MCG::Colour4 col = MCG::Colour4 (1,1,1,1));
    void DrawAiDebug ();
#endif

    void DrawAiPath (BUG::AiPath* path);

    MCG::Real z_distance;
    MCG::Real m_true_w, m_true_h;
	};
}

#endif