/// \file Unit.cpp
/// \date 2008/02/17
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#include "Unit.h"
#include "Instance.h"
#include <assert.h>

namespace Roach
{
	//------------------------------------------------ Unit::Unit
  Unit::Unit( unsigned _instanceID /*= 0*/ ) 
    : m_instanceID (_instanceID)
  {

  }

  //------------------------------------------------ Unit::~Unit
  Unit::~Unit()
  {

  }

  //------------------------------------------------ Unit::Translate
  void Unit::Translate( const BUG::Real& _x, const BUG::Real& _y )
  {
    assert (m_instanceID != 0);
    Application::Instance()->m_world.m_instances[m_instanceID]->m_T.TranslateManual(_x,_y,0,true);
  }

  //------------------------------------------------ Unit::Rotate
  void Unit::Rotate( const BUG::Real& _r )
  {
    assert (m_instanceID != 0);
    Application::Instance()->m_world.m_instances[m_instanceID]->m_T.RotateManual(_r,0,0,1,false);
  }

  //------------------------------------------------ Unit::GetTranslation
  void Unit::GetTranslation( BUG::Real& _x, BUG::Real& _y )
  {
    MCG::Vector2 vect = Application::Instance()->m_world.m_instances[m_instanceID]->m_T.GetTranslation();
    _x = vect.x; _y = vect.y;
  }

  //------------------------------------------------ Unit::GetRotation
  void Unit::GetRotation( BUG::Real& _r )
  {
    MCG::Quaternion quat = Application::Instance()->m_world.m_instances[m_instanceID]->m_T.GetRotation();
    MCG::Real x,y,z;
    quat.ToAxisAngles(x,y,z);
    _r = z;
  }
}