/// \file World.h
/// \date 2008/02/09
/// \author Peter Dodds
/// \brief 
/// \note Copyright (C) 2008 - All Rights Reserved
//------------------------------------------------------------------------------

#ifdef _MSC_VER
#pragma once
#endif

#ifndef _Roach_World_h_
#define _Roach_World_h_

#include <string>
#include <map>
#include "AssetManager.h"

#include <MCG/Def.h>
#include <MCG/Vector2.h>
#include <BUG/AiManager.h>
#include <BUG/AiPath.h>
#include <BUG/AiPathNode.h>

namespace Roach
{
  class Instance;
  class Unit;
    
	/// \brief
	class World
	{
	public:
		//---------------------------------------
		/// \brief Default Constructor
		World();
		//---------------------------------------
		/// \brief Destructor
		~World();

    void Update ();

    bool Load (const char* filename) 
    {
      return false;
    }

    bool Save (const char* filename)
    {
      return false;
    }

    unsigned NewInstance ();
    bool DeleteInstance (unsigned id);

    unsigned NewUnit (unsigned instanceId);
    bool DeleteUnit (unsigned id, bool andInstance = false);

    void ClickWorld (MCG::Real _x, MCG::Real _y, const unsigned button = 0);
    bool HasUserSelection ()
    {
      return (sel_unit || sel_pathnode);
    }

    BUG::AiManager* m_aiMngr;

    AssetManager m_assetMngr;
    std::map<unsigned,Instance*> m_instances;
    std::map<unsigned,Unit*> m_units;

    FRM::FTexture* background;
    MCG::Vector2 bg_size;
    MCG::Vector2 bg_position;

    Unit* sel_unit;
    BUG::AiPathNode* sel_pathnode;
    MCG::Vector2 sel_offset;

    BUG::AiPath lastPath;

  protected:
    std::string m_filename;

	};
}

#endif